<template>
  <div class="catalog-item" @click="selectLayer(layer)">
    <img
      v-if="layer.ThumbnailUrl!=undefined"
      :src="layer.ThumbnailUrl"
      class="image-item"
    />
    <div>
      <h4 class="m-2" :title="layer.Title">{{ layer.Title }}</h4>
      <p class="m-2" :title="layer.OrganisationName">{{ layer.OrganisationName }}</p>
      <p class="m-2" :title="layer.Abstract">
        {{ layer.Abstract.slice(0, 345) }}<span v-if="layer.Abstract.length > 345">...</span>
      </p>
    </div>
  </div>
</template>

<script lang="ts">
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
/* eslint-disable @typescript-eslint/no-explicit-any */
import { OGCLayer } from '@/models/RemoteServer';
import Component from 'vue-class-component';
import BaseComponent from '../../BaseComponent';

@Component({
  name: 'CatalogSearchResult',
  props: {
    layer: {},
    layerType: String,
    selectedLayerList: {},
    selectedStyle: {},
  },
})
export default class CatalogSearchResult extends BaseComponent {
  layer!:any;

  layerType!:string;

  selectedLayerList !:any;

  selectedStyle !:any;

  layerGroup = false;

  hasMultipleStyle = false;

  hasSubLayers = false;

  showSubLayers = true;

  toggle() :void {
    this.showSubLayers = !this.showSubLayers;
  }

  isSelected(result:OGCLayer): boolean {
    if (this.selectedLayerList.length === 0) {
      return false;
    }
    return this.selectedLayerList.find((x:OGCLayer) => x.Title === result.Title) !== undefined;
  }

  mounted() {
    console.log(this.layer);
  }

  selectLayer(layer:any) :void{
    console.log(this.layer);
    this.$emit('selectLayer', layer);
  }
}

</script>

<style scoped lang="less">
@import "../../../styles/variables.less";

.subresults{
  padding-left: 25px;
}

.catalog-item {
  display: flex;
  img {
    height: 60px;
    width: 83px;
    -o-object-fit: cover;
    object-fit: cover;
    border: 1px solid #b4b4b4;
    border-radius: 4px;
  }
  > div {
    width: calc(100% - 83px);
    h4, p + p {
      color: #187cc6;
    }
    h4 {
      border: none;
    }
    p:first-of-type {
      color: rgb(70, 74, 87);
    }
    p {
      font-size: .9rem;
    }
  }
}
.resultItem.selected .catalog-item > div * {
  color: #fff;
}
</style>
